/*----------------------------------------------------------------------------
 *
 * file   : cursor.c for screenshot
 *
 * Author : Yusuf Attarwala
 * Date   : Sep 96
 *
 *---------------------------------------------------------------------------*/
#include <X11/cursorfont.h>

#include "globals.h"
#include "bitmaps.h"

/* function declarations */
static void createCameraCursor();
static void createWindowCursor();
void createCursors();

void 
createCursors()
{
    crossHair  = XCreateFontCursor(display, XC_crosshair);
    busyCursor = XCreateFontCursor(display,XC_watch);
    trackCursor[TrackCenter    ]=XCreateFontCursor(display,XC_fleur);
    trackCursor[TrackTopLeft   ]=XCreateFontCursor(display,XC_top_left_corner);
    trackCursor[TrackTop       ]=XCreateFontCursor(display,XC_top_side);
    trackCursor[TrackTopRight  ]=XCreateFontCursor(display,XC_top_right_corner);
    trackCursor[TrackRight     ]=XCreateFontCursor(display,XC_right_side);
    trackCursor[TrackBottomRight]=XCreateFontCursor(display,XC_bottom_right_corner);
    trackCursor[TrackBottom    ]=XCreateFontCursor(display,XC_bottom_side);
    trackCursor[TrackBottomLeft]=XCreateFontCursor(display,XC_bottom_left_corner);
    trackCursor[TrackLeft      ]=XCreateFontCursor(display,XC_left_side);

    createCameraCursor();
    createWindowCursor();

    trackCursor[TrackOutside] = cameraCursor;

    /* temp */
    {
        Pixel bg,fg;
        XtVaGetValues(toplevel,XmNforeground,&fg,XmNbackground,&bg,NULL);
        if (bg <=50 ) {
            cameraPixmap = XCreatePixmapFromBitmapData(display,rootWindow,
			    ss_bits,ss_width,ss_height,
			    brownColor.pixel,bg,DefaultDepth(display,screen));
        }
	else {
            cameraPixmap = XCreatePixmapFromBitmapData(display,rootWindow,
			    ss_bits,ss_width,ss_height,
			    fg,bg,DefaultDepth(display,screen));
	}
    }
}


static void 
createCameraCursor()
{
    Pixmap pix, mask;
    XColor f, b;
    Colormap ccc;
    pix = XCreatePixmapFromBitmapData(display, rootWindow, 
                  camera_bits, camera_width, camera_height, 
		  1, 0, 1);
    mask = XCreatePixmapFromBitmapData(display,
                  rootWindow, camera_mask_bits, camera_mask_width,
                  camera_mask_height, 1, 0, 1);
    f.red = 244 << 8;
    f.blue = f.green = 0;
    f.flags = DoRed | DoGreen | DoBlue;
    ccc = XDefaultColormap(display, screen);
    XAllocColor(display, ccc, &f);
    b.pixel = 0;

    cameraCursor = XCreatePixmapCursor(display, mask, pix,
        &b, &f, camera_x_hot, camera_y_hot);
}

static void 
createWindowCursor()
{
    Pixmap pix, mask;
    XColor f, b;
    Colormap ccc;
    pix = XCreatePixmapFromBitmapData(display,
                  rootWindow, (char*) window_bits, window_width,
                  window_height, 1, 0, 1);
    mask = XCreatePixmapFromBitmapData(display,
                  rootWindow, (char*) window_mask_bits, window_mask_width,
                  window_mask_height, 1, 0, 1);
    f.red = 244 << 8;
    f.blue = f.green = 0;
    f.flags = DoRed | DoGreen | DoBlue;
    ccc = XDefaultColormap(display, screen);
    XAllocColor(display, ccc, &f);
    b.pixel = 0xffffff;

    windowCursor = XCreatePixmapCursor(display, mask, pix,
        &b, &f, window_x_hot, window_y_hot);
}
