/*----------------------------------------------------------------------------
 * 
 * file   : help.c 
 * 
 * Author : Yusuf Attarwala
 * Date   : Sep 96
 * 
 *---------------------------------------------------------------------------*/

#include "Xmincludes.h"
#include "globals.h"

static Arg args[40];

Widget createHelpDialog();
void popDownHelp();

static char helpText[] = "\
                    ScreenShot - an image capturing utility.\n\
		        (inspired by ratman's snapshot)\n\n\
ScreenShot allows you to capture regions of screen into an image file.\n\n\
Sweeping Regions:\n\
When you select 'Sweep Region' from the menu, use Left mouse to create or\n\
manipulate the region. Click Middle mouse when done. To resume sweeping, select\n\
the menu entry 'Sweep Region'.\n\
Note: For fine tuning use keyboard arrow keys.\n\n\
Capturing Region:\n\
Select the first menu entry 'Capture Region'.\n\
This will capture the swept region which can be then previewed using \n\
the Preview entry from the menu.\n\n\
Settings:\n\
There are several capture modes available:\n\n\
1) Capture Region :     Capture a swept region (default)\n\
2) Capture Window :     Select a window to be captured\n\
3) Capture FullScreen : Captures the entire screen\n\
4) Capture NTSC :       Captures NTSC resolution region\n\
5) Capture PAL  :       Capture PAL resolution region\n\n\
After you set one of these modes, you can begin image capture,\n\
using the first menu entry. In certain modes, the UI will temporarily\n\
disappear during the capturing phase.\n\n\
Maintain Aspect Ratio:\n\
The ratio of current width to height is maintained while sweeping.\n\n\
Maintain Square:\n\
The ratio of width to height is locked to 1.0\n\n\
Auto File-Name Increment:\n\
Enabling this will automatically increment the file name counter\n\
which is used for capturing frames from a predefined region.\n\n\
Delay Seconds:\n\
This is used for capturing transient windows. The capturing of\n\
image will start after so many seconds after you click on the first\n\
menu entry.\n\n\
Other KeyBoard Shortcuts :\n\
F1 key     : Begin Capture\n\
Escape Key : exit\n\
Arrow Keys : for fine tuning sweep region\n\
Ctrl Key   : accelator while fine tuning with arrow key\n\
Shitf Key  : accelator while fine tuning with arrow key\n\
";


void
popDownHelp(w,dialog)
Widget w,dialog;
{
    XtUnmanageChild(dialog);
}


Widget
createHelpDialog(parent)
Widget parent;
{
    Widget dialog,workArea;
    Widget stext;
    int i,n;
    Arg args[5];

    n = 0;
    XtSetArg(args[n],XmNautoUnmanage,False);n++;
    XtSetArg(args[n],XmNmarginHeight,1);n++;
    XtSetArg(args[n],XmNtitle,"ScreenShot Help");n++;
    XtSetArg(args[n],XmNallowResize,False);n++;
    dialog = XmCreatePromptDialog(toplevel,"selecton",args,n);
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_PROMPT_LABEL));
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_COMMAND_TEXT));
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON));

    XtAddCallback(XmSelectionBoxGetChild(dialog,XmDIALOG_OK_BUTTON),
		  XmNactivateCallback,(XtPointer)popDownHelp,dialog);

    workArea = XtVaCreateManagedWidget("workArea", 
                                        xmRowColumnWidgetClass,dialog, 
					XmNmarginHeight,1,
					NULL);

    n = 0;

    XtSetArg(args[n],XmNwordWrap, True);n++;
    XtSetArg(args[n],XmNeditMode,XmMULTI_LINE_EDIT);n++;
    XtSetArg(args[n],XmNrows,30);n++;
    XtSetArg(args[n],XmNcolumns,80);n++;
    XtSetArg(args[n],XmNeditable,False);n++;
    stext = XmCreateScrolledText(workArea,"stext", args,n);
    XtManageChild(stext);

    XmTextSetString(stext,helpText);

    return dialog;
}

void
helpCB()
{
    XtManageChild(helpDialog);
}

