/*----------------------------------------------------------------------------
 * 
 * file   : menu.c 
 * 
 * 
 *---------------------------------------------------------------------------*/

#include <Xm/CascadeB.h>
#include <Xm/CascadeBG.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/SelectioB.h>
#include <Xm/SeparatoG.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include <Xm/ToggleB.h>
#include <Xm/ToggleBG.h>

#include "globals.h"

Arg args[40];
int argcnt;

Widget 
buildMenu(parent,menuType,menuTitle,mnemonic,items)
Widget parent;
int menuType;
char *menuTitle,mnemonic;
MenuItem *items;
{
    Widget menu,cascade,widget;
    int i;
    XmString str;

    if (menuType == XmMENU_PULLDOWN || menuType == XmMENU_OPTION) {
        menu = XmCreatePulldownMenu(parent,"pulldown",NULL,0);
    }
    else if (menuType == XmMENU_POPUP) {
        menu = XmCreatePopupMenu(parent,"popup",NULL,0);
    }
    else {
	XtWarning("Invalid menu type passed to buildMenu()");
	return NULL;
    }

    /* pull down menus require a cascase button to be made */
    if (menuType == XmMENU_PULLDOWN ) {
        str = XmStringCreateSimple(menuTitle);
        cascade = XtVaCreateManagedWidget(menuTitle,
	             xmCascadeButtonGadgetClass,parent,
	             XmNsubMenuId,              menu,
	             XmNlabelString,            str,
	             XmNmnemonic,               mnemonic,
	             NULL);
        XmStringFree(str);
    }
    else {
	str = XmStringCreateSimple(menuTitle);
	XtSetArg(args[0],XmNsubMenuId,  menu);
	XtSetArg(args[1],XmNlabelString,str);
	cascade = XmCreateOptionMenu(parent,menuTitle,args,2);
	XmStringFree(str);
    }

    /* now add the menu items */
    for (i=0;items[i].label != NULL;i++) {

        if (items[i].mnemonic == '*') continue;

	/* create rollover menu if specified */
	if (items[i].subItems != NULL) {
            if (menuType == XmMENU_OPTION ) {
		/*
	        XtWarning("You can't have submenus for option menu items");
		*/
		continue;
	    }
	    else {
	        widget = buildMenu(menu,XmMENU_PULLDOWN,
		             items[i].label,items[i].mnemonic,items[i].subItems);
	    }
	}
	else {
	    items[i].widget = XtVaCreateManagedWidget(items[i].label,
		              *items[i].class,menu,
		              NULL);
	}

	if (items[i].mnemonic) 
	    XtVaSetValues(items[i].widget,XmNmnemonic,items[i].mnemonic,NULL);

        /* greyed out */
        if (items[i].mnemonic == '@') 
	    XtVaSetValues(items[i].widget,XmNsensitive,0,NULL);

	if (items[i].accelerator) {
	    str = XmStringCreateSimple(items[i].accelText);
	    XtVaSetValues(items[i].widget,
		XmNaccelerator,items[i].accelerator,
		XmNacceleratorText,str,
		NULL);
	    XmStringFree(str);
	}
	
	if (items[i].callback) {
	    XtAddCallback(items[i].widget,
		(items[i].class == &xmToggleButtonWidgetClass || 
		 items[i].class == &xmToggleButtonGadgetClass) ?
		 XmNvalueChangedCallback : /* ToggleButton Class */
		 XmNactivateCallback,      /* PushButton Class */
		 items[i].callback,items[i].callbackData);
	}
    }
    /* for popup ,   return menu,
       for pulldown, return cascade,
       for option,   return widget from XmCreateOption
    */
    return menuType == XmMENU_POPUP ? menu : cascade;
}
